"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@ts-ioc/core");
/**
 * application runner token.
 *
 * @export
 * @class InjectRunnerToken
 * @extends {Registration<IRunner<T>>}
 * @template T
 */
class InjectRunnableToken extends core_1.RefRegistration {
    constructor(type) {
        super(type, 'Runnable');
    }
    static getClassAnnations() {
        return { "name": "InjectRunnableToken", "params": { "constructor": ["type"] } };
    }
}
exports.InjectRunnableToken = InjectRunnableToken;
/**
 * default service token.
 */
exports.ServiceToken = new InjectRunnableToken('service');
/**
 * default runner token.
 */
exports.RunnerToken = new InjectRunnableToken('runner');

//# sourceMappingURL=../sourcemaps/runnable/types.js.map
