import { AppConfigure } from './AppConfigure';
import { IApplicationBuilder } from './IApplicationBuilder';
import { IEvents } from '../utils';
import { RunnableBuilder, RunnableEvents } from './RunnableBuilder';
import { IConfigureManager } from './IConfigureManager';
import { ModuleConfigure } from '../modules';
/**
 * application events
 *
 * @export
 * @enum {number}
 */
export declare const AppEvents: typeof RunnableEvents;
/**
 * application events
 */
export declare const ApplicationEvents: typeof RunnableEvents;
/**
 * application builder.
 *
 * @export
 * @class Default ApplicationBuilder
 * @extends {ModuleBuilder}
 * @template T
 */
export declare class ApplicationBuilder<T> extends RunnableBuilder<T> implements IApplicationBuilder<T>, IEvents {
    protected configs: (string | AppConfigure)[];
    constructor(baseURL?: string);
    /**
     * use configuration.
     *
     * @param {(string | AppConfigure)} [config]
     * @returns {this} global config for this application.
     * @memberof Bootstrap
     */
    useConfiguration(config?: string | AppConfigure): this;
    protected createConfigureMgr(): IConfigureManager<ModuleConfigure>;
    static getClassAnnations(): any;
}
