"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var runnable_1 = require("../runnable");
/**
 * boot
 *
 * @export
 * @abstract
 * @class Boot
 * @extends {Service<T>}
 * @implements {IBoot<T>}
 * @template T
 */
var Boot = /** @class */ (function (_super) {
    tslib_1.__extends(Boot, _super);
    function Boot() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * on boot init.
     *
     * @param {RunnableOptions<T>} options
     * @param {RunOptions<T>} bootOptions
     * @returns {Promise<void>}
     * @memberof IBoot
     */
    Boot.prototype.onInit = function (options, bootOptions) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, _super.prototype.onInit.call(this, options, bootOptions)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * run boot.
     *
     * @abstract
     * @param {*} [data]
     * @returns {Promise<any>}
     * @memberof Boot
     */
    Boot.prototype.run = function (data) {
        return this.start(data);
    };
    Boot.getClassAnnations = function () {
        return { "name": "Boot", "params": { "onInit": ["options", "bootOptions"], "run": ["data"] } };
    };
    return Boot;
}(runnable_1.Service));
exports.Boot = Boot;

//# sourceMappingURL=../sourcemaps/boot/boots.js.map
