import { Token, IContainer, Registration, Type, IExports, ParamProviders, Factory, IResolver, ResoveWay, IResolverContainer } from '@ts-ioc/core';
import { ModuleConfig } from './ModuleConfigure';
/**
 * injected module.
 *
 * @export
 * @class InjectedModule
 * @template T
 */
export declare class InjectedModule<T> implements IExports {
    token: Token<T>;
    config: ModuleConfig<T>;
    container: IContainer;
    type?: Type<any>;
    exports?: IResolverContainer;
    constructor(token: Token<T>, config: ModuleConfig<T>, container: IContainer, type?: Type<any>, exports?: IResolverContainer);
    getProviderMap(): IResolverContainer;
    readonly size: number;
    resolve<T>(token: Token<T>, resway?: ResoveWay | ParamProviders, ...providers: ParamProviders[]): T;
    has<T>(token: Token<T>, aliasOrway?: string | ResoveWay): boolean;
    getTokenImpl<T>(token: Token<T>, resway?: ResoveWay): Type<T>;
    unregister<T>(token: Token<T>, resway?: ResoveWay): this;
    forEach(callbackfn: (tk: Token<any>, fac: Factory<any>, resolvor?: IResolver) => void | boolean): void | boolean;
    static getClassAnnations(): any;
}
/**
 * Injected Module Token.
 *
 * @export
 * @class InjectModuleMetaConfigToken
 * @extends {Registration<Type<T>>}
 * @template T
 */
export declare class InjectedModuleToken<T> extends Registration<InjectedModule<T>> {
    constructor(type: Type<T>);
    static getClassAnnations(): any;
}
