"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@ts-ioc/core");
/**
 * runnable options token.
 */
exports.RunnableOptionsToken = new core_1.InjectToken('boot_runnable_options');
/**
 * boot.
 *
 * @export
 * @class Boot
 * @implements {IBoot<T>}
 * @template T
 */
var RunnableBase = /** @class */ (function () {
    function RunnableBase(options) {
        this._options = options;
    }
    Object.defineProperty(RunnableBase.prototype, "options", {
        get: function () {
            return this._options;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RunnableBase.prototype, "bootOptions", {
        get: function () {
            return this._bootOptions;
        },
        enumerable: true,
        configurable: true
    });
    RunnableBase.prototype.onInit = function (options, bootOptions) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (options) {
                    this._options = options;
                }
                this._bootOptions = bootOptions;
                return [2 /*return*/];
            });
        });
    };
    RunnableBase.prototype.getTarget = function () {
        return this.options.instance;
    };
    RunnableBase.prototype.getModuleToken = function () {
        return this.options.mdToken;
    };
    RunnableBase.prototype.getTargetType = function () {
        return this.options.type || core_1.lang.getClass(this.options.instance);
    };
    RunnableBase.getClassAnnations = function () {
        return { "name": "RunnableBase", "params": { "constructor": ["options"], "onInit": ["options", "bootOptions"], "getTarget": [], "getModuleToken": [], "getTargetType": [] } };
    };
    tslib_1.__decorate([
        core_1.Inject(core_1.ContainerToken),
        tslib_1.__metadata("design:type", Object)
    ], RunnableBase.prototype, "container", void 0);
    return RunnableBase;
}());
exports.RunnableBase = RunnableBase;
/**
 * target is Runnable or not.
 *
 * @export
 * @param {*} target
 * @returns {target is RunnableBase<any>}
 */
function isRunnable(target) {
    if (target instanceof RunnableBase) {
        return true;
    }
    return false;
}
exports.isRunnable = isRunnable;

//# sourceMappingURL=../sourcemaps/runnable/Runnable.js.map
