"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@ts-ioc/core");
var Runnable_1 = require("./Runnable");
/**
 * boot element.
 *
 * @export
 * @abstract
 * @class Boot
 * @implements {IBoot}
 */
var Runner = /** @class */ (function (_super) {
    tslib_1.__extends(Runner, _super);
    function Runner(options) {
        return _super.call(this, options) || this;
    }
    Runner.getClassAnnations = function () {
        return { "name": "Runner", "params": { "constructor": ["options"], "run": ["data"] } };
    };
    return Runner;
}(Runnable_1.RunnableBase));
exports.Runner = Runner;
/**
 * target is runner or not.
 *
 * @export
 * @param {*} target
 * @returns {target is IRunner<any>}
 */
function isRunner(target) {
    if (target instanceof Runner) {
        return true;
    }
    if (target && core_1.isFunction(target.run)) {
        return true;
    }
    return false;
}
exports.isRunner = isRunner;

//# sourceMappingURL=../sourcemaps/runnable/Runner.js.map
