import { Token, SymbolType, IContainer, InjectToken, IContainerBuilder } from '@ts-ioc/core';
/**
 * container pool
 *
 * @export
 * @class ContainerPool
 */
export declare class ContainerPool {
    protected containerBuilder: IContainerBuilder;
    protected pools: Map<Token<any>, IContainer[]>;
    constructor(containerBuilder: IContainerBuilder);
    protected createContainer(): IContainer;
    getTokenKey(token: Token<any>): SymbolType<any>;
    isDefault(container: IContainer): boolean;
    hasDefault(): boolean;
    _default: IContainer;
    getDefault(): IContainer;
    set(token: Token<any>, container: IContainer): void;
    get(token: Token<any>): IContainer[];
    has(token: Token<any>): boolean;
    create(token: Token<any>, parent?: IContainer): IContainer;
    setParent(container: IContainer, parent?: IContainer): void;
    keys(): Token<any>[];
    values(): IContainer[];
    iterator(express: (resolvor?: IContainer) => void, root?: IContainer): void;
    protected iteratorChildren(express: (resolvor?: IContainer) => void, children: IContainer[]): void;
    static getClassAnnations(): any;
}
/**
 *  container pool token.
 */
export declare const ContainerPoolToken: InjectToken<ContainerPool>;
